import { HapClient } from "./3rdParty/HapClient";
import { HapMonitor } from "./3rdParty/HapClient/monitor";

let Accessory: any;
let Homebridge: any;

/**
 * Main entry.
 * @param homebridge 
 */
export default function (homebridge: any) {
    Homebridge = homebridge;
    Accessory = homebridge.platformAccessory;
    homebridge.registerPlatform(
        'ml-automation',
        'automation',
        AutomationPlatform,
        true
    );
};

class AutomationPlatform {
    log: any = {};
    config: any = {};
    api: any;
    client: HapClient;

    constructor(log: any, config: any, api: any) {
        this.log = log;
        this.config = config;
        this.api = api;
        this.log('INFO - Registering automation platform');
        this.api.on('didFinishLaunching', this.didFinishLaunching.bind(this));

        this.client = new HapClient({
            pin: "031-45-154",
            logger: log,
            config: config
        });

        this.client.on('instance-discovered', async (instance: any) => {
            let asdf = instance;

        })
    }




    /**
     * Handler for didFinishLaunching
     * Happens after constructor
     */
    didFinishLaunching() {
        //No external accessories to publish
    }

    /**
     * Called by homebridge to gather accessories.
     * @param callback 
     */
    accessories(callback: (accessories: Array<any>) => void) {

    }
}